import 'event.dart';
import 'timezone.dart';

/// Parsed calendar generated by [parseCalendar]
class ParsedCalendar {
  String version = "";
  String prodID = "";
  String calscale = "";

  /// Timezone standard and daylight
  Timezone timezone = Timezone();

  List<Event> events = <Event>[];

  ParsedCalendar();

  void set(String key, String value) {
    switch (key) {
      case "VERSION":
        version = value;
        break;
      case "PRODID":
        prodID = value;
        break;
      case "CALSCALE":
        calscale = value;
        break;
      default:
        print("Invalid key: $key");
        if (value != null) {
          print("with value: $value");
        }
    }
  }
}
